import random
from character import *
     
# -- retrieve the cost of the cheapest rank
def minimum_cost (attributes, race):
    minimum = 1000
    
    for attribute in attributes [:]:
        cost = table.advancement.cost (race, attribute)
        if minimum > cost: minimum = cost

    return minimum


# -- randomly level up a creature
def level_up (char, points):
    attributes = table.advancement.attributes (char.Race)
    number = len (attributes)
    
    # -- determine the minimum cost for leveling up attributes
    min_cost = minimum_cost (attributes, char.Race)
    
    while points >= min_cost:
        attribute = attributes[random.randrange (0, number)]
        
        # -- do not raise attributes that are too costly
        if points < table.advancement.cost (char.Race, attribute): 
            continue
        
        # -- do not exceed maximum
        if char.increase (attribute, 1):
            points = points - table.advancement.cost (char.Race, attribute)
        else:
            # -- attribute can't be raised any more
            attributes.remove (attribute)

            # -- are there attributes to raise left?
            number = len (attributes)
            if number == 0: return
            
            # -- recalculate minimum
            min_cost = minimum_cost (attributes, char.Race)

        
# -- test code
wolf = base.base ("Wolf")

while 1:
    wolf.Strength = 0
    wolf.Hardness = 0
    wolf.Agility = 0
    wolf.Willpower = 0
    
    level = input ("Select level of creature (0 to quit): ")
    if level <= 0: break 
    
    level_up (wolf, level * 5)
    
    print "Strength  =", wolf.Strength
    print "Hardness  =", wolf.Hardness
    print "Agility   =", wolf.Agility
    print "Willpower =", wolf.Willpower
    print "---------------"
