#
#  $Id$
#
#  (C) Copyright 2003 Kai Sterker <kaisterker@linuxgames.com>
#  Part of the Adonthell Project http://adonthell.linuxgames.com
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License.
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY.
#
#  See the COPYING file for more details
#

import table

#
# This is the base class for all characters. It implements attributes
# and methods common to all characters. Characters that need additional
# attributes will have to extend this class.
#
class base (object):
    def __init__ (self, race):
        # -- the character's race (a string)
        self.Race = race
    
    # -- safely increase an attribute
    def increase (self, attribute, amount):
        if not hasattr (self, attribute): return 0
        
        value = self.__dict__[attribute] + amount
        maximum = table.advancement.maximum (self.Race, attribute)
        
        # -- do not exceed maximum
        if value > maximum: 
            self.__dict__[attribute] = maximum
            return 0
        else:
            self.__dict__[attribute] = value
            return 1
    
    # -- safely decrease an attribute
    def decrease (self, attribute, amount):
        if not hasattr (self, attribute): return 0

        value = self.__dict__[attribute] - amount
        
        # -- do not drop below minimum
        if value < 0:
            self.__dict__[attribute] = 0
            return 0
        else:
            self.__dict__[attribute] = value
            return 1
